<?php
/**
 * Seller
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\BuClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi. BU. Продавцы
 *
 * Управление продавцами
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\BuClient\Dto;

use \ArrayAccess;
use \Ensi\BuClient\ObjectSerializer;

/**
 * Seller Class Doc Comment
 *
 * @category Class
 * @package  Ensi\BuClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class Seller implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'Seller';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'status_at' => '\DateTime',
        'created_at' => '\DateTime',
        'updated_at' => '\DateTime',
        'manager_id' => 'int',
        'legal_name' => 'string',
        'legal_address' => '\Ensi\BuClient\Dto\Address',
        'fact_address' => '\Ensi\BuClient\Dto\Address',
        'inn' => 'string',
        'kpp' => 'string',
        'payment_account' => 'string',
        'correspondent_account' => 'string',
        'bank' => 'string',
        'bank_address' => '\Ensi\BuClient\Dto\Address',
        'bank_bik' => 'string',
        'site' => 'string',
        'info' => 'string',
        'status' => 'int',
        'operators' => '\Ensi\BuClient\Dto\Operator[]',
        'stores' => '\Ensi\BuClient\Dto\Store[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'status_at' => 'date-time',
        'created_at' => 'date-time',
        'updated_at' => 'date-time',
        'manager_id' => null,
        'legal_name' => null,
        'legal_address' => null,
        'fact_address' => null,
        'inn' => null,
        'kpp' => null,
        'payment_account' => null,
        'correspondent_account' => null,
        'bank' => null,
        'bank_address' => null,
        'bank_bik' => null,
        'site' => null,
        'info' => null,
        'status' => null,
        'operators' => null,
        'stores' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'status_at' => false,
        'created_at' => false,
        'updated_at' => false,
        'manager_id' => true,
        'legal_name' => false,
        'legal_address' => true,
        'fact_address' => true,
        'inn' => true,
        'kpp' => true,
        'payment_account' => true,
        'correspondent_account' => true,
        'bank' => true,
        'bank_address' => true,
        'bank_bik' => true,
        'site' => true,
        'info' => true,
        'status' => false,
        'operators' => false,
        'stores' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::openAPINullables()[$property])) {
            return self::openAPINullables()[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'status_at' => 'status_at',
        'created_at' => 'created_at',
        'updated_at' => 'updated_at',
        'manager_id' => 'manager_id',
        'legal_name' => 'legal_name',
        'legal_address' => 'legal_address',
        'fact_address' => 'fact_address',
        'inn' => 'inn',
        'kpp' => 'kpp',
        'payment_account' => 'payment_account',
        'correspondent_account' => 'correspondent_account',
        'bank' => 'bank',
        'bank_address' => 'bank_address',
        'bank_bik' => 'bank_bik',
        'site' => 'site',
        'info' => 'info',
        'status' => 'status',
        'operators' => 'operators',
        'stores' => 'stores'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'status_at' => 'setStatusAt',
        'created_at' => 'setCreatedAt',
        'updated_at' => 'setUpdatedAt',
        'manager_id' => 'setManagerId',
        'legal_name' => 'setLegalName',
        'legal_address' => 'setLegalAddress',
        'fact_address' => 'setFactAddress',
        'inn' => 'setInn',
        'kpp' => 'setKpp',
        'payment_account' => 'setPaymentAccount',
        'correspondent_account' => 'setCorrespondentAccount',
        'bank' => 'setBank',
        'bank_address' => 'setBankAddress',
        'bank_bik' => 'setBankBik',
        'site' => 'setSite',
        'info' => 'setInfo',
        'status' => 'setStatus',
        'operators' => 'setOperators',
        'stores' => 'setStores'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'status_at' => 'getStatusAt',
        'created_at' => 'getCreatedAt',
        'updated_at' => 'getUpdatedAt',
        'manager_id' => 'getManagerId',
        'legal_name' => 'getLegalName',
        'legal_address' => 'getLegalAddress',
        'fact_address' => 'getFactAddress',
        'inn' => 'getInn',
        'kpp' => 'getKpp',
        'payment_account' => 'getPaymentAccount',
        'correspondent_account' => 'getCorrespondentAccount',
        'bank' => 'getBank',
        'bank_address' => 'getBankAddress',
        'bank_bik' => 'getBankBik',
        'site' => 'getSite',
        'info' => 'getInfo',
        'status' => 'getStatus',
        'operators' => 'getOperators',
        'stores' => 'getStores'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('status_at', $data, null);
        $this->setIfExists('created_at', $data, null);
        $this->setIfExists('updated_at', $data, null);
        $this->setIfExists('manager_id', $data, null);
        $this->setIfExists('legal_name', $data, null);
        $this->setIfExists('legal_address', $data, null);
        $this->setIfExists('fact_address', $data, null);
        $this->setIfExists('inn', $data, null);
        $this->setIfExists('kpp', $data, null);
        $this->setIfExists('payment_account', $data, null);
        $this->setIfExists('correspondent_account', $data, null);
        $this->setIfExists('bank', $data, null);
        $this->setIfExists('bank_address', $data, null);
        $this->setIfExists('bank_bik', $data, null);
        $this->setIfExists('site', $data, null);
        $this->setIfExists('info', $data, null);
        $this->setIfExists('status', $data, null);
        $this->setIfExists('operators', $data, null);
        $this->setIfExists('stores', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['id'] === null) {
            $invalidProperties[] = "'id' can't be null";
        }
        if ($this->container['status_at'] === null) {
            $invalidProperties[] = "'status_at' can't be null";
        }
        if ($this->container['created_at'] === null) {
            $invalidProperties[] = "'created_at' can't be null";
        }
        if ($this->container['updated_at'] === null) {
            $invalidProperties[] = "'updated_at' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int $id Идентификатор продавца
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets status_at
     *
     * @return \DateTime
     */
    public function getStatusAt()
    {
        return $this->container['status_at'];
    }

    /**
     * Sets status_at
     *
     * @param \DateTime $status_at Время изменения статуса продавца
     *
     * @return $this
     */
    public function setStatusAt($status_at)
    {


        /*if (is_null($status_at)) {
            throw new \InvalidArgumentException('non-nullable status_at cannot be null');
        }*/
        $this->container['status_at'] = $status_at;

        return $this;
    }

    /**
     * Gets created_at
     *
     * @return \DateTime
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     *
     * @param \DateTime $created_at Время создания продавца
     *
     * @return $this
     */
    public function setCreatedAt($created_at)
    {


        /*if (is_null($created_at)) {
            throw new \InvalidArgumentException('non-nullable created_at cannot be null');
        }*/
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets updated_at
     *
     * @return \DateTime
     */
    public function getUpdatedAt()
    {
        return $this->container['updated_at'];
    }

    /**
     * Sets updated_at
     *
     * @param \DateTime $updated_at Время обновления продавца
     *
     * @return $this
     */
    public function setUpdatedAt($updated_at)
    {


        /*if (is_null($updated_at)) {
            throw new \InvalidArgumentException('non-nullable updated_at cannot be null');
        }*/
        $this->container['updated_at'] = $updated_at;

        return $this;
    }

    /**
     * Gets manager_id
     *
     * @return int|null
     */
    public function getManagerId()
    {
        return $this->container['manager_id'];
    }

    /**
     * Sets manager_id
     *
     * @param int|null $manager_id ID менеджера
     *
     * @return $this
     */
    public function setManagerId($manager_id)
    {

        if (is_null($manager_id)) {
            array_push($this->openAPINullablesSetToNull, 'manager_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('manager_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['manager_id'] = $manager_id;

        return $this;
    }

    /**
     * Gets legal_name
     *
     * @return string|null
     */
    public function getLegalName()
    {
        return $this->container['legal_name'];
    }

    /**
     * Sets legal_name
     *
     * @param string|null $legal_name Юридическое наименование организации
     *
     * @return $this
     */
    public function setLegalName($legal_name)
    {


        /*if (is_null($legal_name)) {
            throw new \InvalidArgumentException('non-nullable legal_name cannot be null');
        }*/
        $this->container['legal_name'] = $legal_name;

        return $this;
    }

    /**
     * Gets legal_address
     *
     * @return \Ensi\BuClient\Dto\Address|null
     */
    public function getLegalAddress()
    {
        return $this->container['legal_address'];
    }

    /**
     * Sets legal_address
     *
     * @param \Ensi\BuClient\Dto\Address|null $legal_address legal_address
     *
     * @return $this
     */
    public function setLegalAddress($legal_address)
    {

        if (is_null($legal_address)) {
            array_push($this->openAPINullablesSetToNull, 'legal_address');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('legal_address', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['legal_address'] = $legal_address;

        return $this;
    }

    /**
     * Gets fact_address
     *
     * @return \Ensi\BuClient\Dto\Address|null
     */
    public function getFactAddress()
    {
        return $this->container['fact_address'];
    }

    /**
     * Sets fact_address
     *
     * @param \Ensi\BuClient\Dto\Address|null $fact_address fact_address
     *
     * @return $this
     */
    public function setFactAddress($fact_address)
    {

        if (is_null($fact_address)) {
            array_push($this->openAPINullablesSetToNull, 'fact_address');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('fact_address', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['fact_address'] = $fact_address;

        return $this;
    }

    /**
     * Gets inn
     *
     * @return string|null
     */
    public function getInn()
    {
        return $this->container['inn'];
    }

    /**
     * Sets inn
     *
     * @param string|null $inn ИНН
     *
     * @return $this
     */
    public function setInn($inn)
    {

        if (is_null($inn)) {
            array_push($this->openAPINullablesSetToNull, 'inn');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('inn', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['inn'] = $inn;

        return $this;
    }

    /**
     * Gets kpp
     *
     * @return string|null
     */
    public function getKpp()
    {
        return $this->container['kpp'];
    }

    /**
     * Sets kpp
     *
     * @param string|null $kpp КПП
     *
     * @return $this
     */
    public function setKpp($kpp)
    {

        if (is_null($kpp)) {
            array_push($this->openAPINullablesSetToNull, 'kpp');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('kpp', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['kpp'] = $kpp;

        return $this;
    }

    /**
     * Gets payment_account
     *
     * @return string|null
     */
    public function getPaymentAccount()
    {
        return $this->container['payment_account'];
    }

    /**
     * Sets payment_account
     *
     * @param string|null $payment_account Номер банковского счета
     *
     * @return $this
     */
    public function setPaymentAccount($payment_account)
    {

        if (is_null($payment_account)) {
            array_push($this->openAPINullablesSetToNull, 'payment_account');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('payment_account', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['payment_account'] = $payment_account;

        return $this;
    }

    /**
     * Gets correspondent_account
     *
     * @return string|null
     */
    public function getCorrespondentAccount()
    {
        return $this->container['correspondent_account'];
    }

    /**
     * Sets correspondent_account
     *
     * @param string|null $correspondent_account Номер корреспондентского счета банка
     *
     * @return $this
     */
    public function setCorrespondentAccount($correspondent_account)
    {

        if (is_null($correspondent_account)) {
            array_push($this->openAPINullablesSetToNull, 'correspondent_account');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('correspondent_account', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['correspondent_account'] = $correspondent_account;

        return $this;
    }

    /**
     * Gets bank
     *
     * @return string|null
     */
    public function getBank()
    {
        return $this->container['bank'];
    }

    /**
     * Sets bank
     *
     * @param string|null $bank Наименование банка
     *
     * @return $this
     */
    public function setBank($bank)
    {

        if (is_null($bank)) {
            array_push($this->openAPINullablesSetToNull, 'bank');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('bank', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['bank'] = $bank;

        return $this;
    }

    /**
     * Gets bank_address
     *
     * @return \Ensi\BuClient\Dto\Address|null
     */
    public function getBankAddress()
    {
        return $this->container['bank_address'];
    }

    /**
     * Sets bank_address
     *
     * @param \Ensi\BuClient\Dto\Address|null $bank_address bank_address
     *
     * @return $this
     */
    public function setBankAddress($bank_address)
    {

        if (is_null($bank_address)) {
            array_push($this->openAPINullablesSetToNull, 'bank_address');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('bank_address', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['bank_address'] = $bank_address;

        return $this;
    }

    /**
     * Gets bank_bik
     *
     * @return string|null
     */
    public function getBankBik()
    {
        return $this->container['bank_bik'];
    }

    /**
     * Sets bank_bik
     *
     * @param string|null $bank_bik БИК банка
     *
     * @return $this
     */
    public function setBankBik($bank_bik)
    {

        if (is_null($bank_bik)) {
            array_push($this->openAPINullablesSetToNull, 'bank_bik');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('bank_bik', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['bank_bik'] = $bank_bik;

        return $this;
    }

    /**
     * Gets site
     *
     * @return string|null
     */
    public function getSite()
    {
        return $this->container['site'];
    }

    /**
     * Sets site
     *
     * @param string|null $site Сайт компании
     *
     * @return $this
     */
    public function setSite($site)
    {

        if (is_null($site)) {
            array_push($this->openAPINullablesSetToNull, 'site');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('site', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['site'] = $site;

        return $this;
    }

    /**
     * Gets info
     *
     * @return string|null
     */
    public function getInfo()
    {
        return $this->container['info'];
    }

    /**
     * Sets info
     *
     * @param string|null $info Бренды и товары, которыми торгует Продавец
     *
     * @return $this
     */
    public function setInfo($info)
    {

        if (is_null($info)) {
            array_push($this->openAPINullablesSetToNull, 'info');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('info', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['info'] = $info;

        return $this;
    }

    /**
     * Gets status
     *
     * @return int|null
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param int|null $status Статус продавца из SellerStatusEnum
     *
     * @return $this
     */
    public function setStatus($status)
    {


        /*if (is_null($status)) {
            throw new \InvalidArgumentException('non-nullable status cannot be null');
        }*/
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets operators
     *
     * @return \Ensi\BuClient\Dto\Operator[]|null
     */
    public function getOperators()
    {
        return $this->container['operators'];
    }

    /**
     * Sets operators
     *
     * @param \Ensi\BuClient\Dto\Operator[]|null $operators operators
     *
     * @return $this
     */
    public function setOperators($operators)
    {


        /*if (is_null($operators)) {
            throw new \InvalidArgumentException('non-nullable operators cannot be null');
        }*/
        $this->container['operators'] = $operators;

        return $this;
    }

    /**
     * Gets stores
     *
     * @return \Ensi\BuClient\Dto\Store[]|null
     */
    public function getStores()
    {
        return $this->container['stores'];
    }

    /**
     * Sets stores
     *
     * @param \Ensi\BuClient\Dto\Store[]|null $stores stores
     *
     * @return $this
     */
    public function setStores($stores)
    {


        /*if (is_null($stores)) {
            throw new \InvalidArgumentException('non-nullable stores cannot be null');
        }*/
        $this->container['stores'] = $stores;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset): mixed
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }

    /**
    * Convert object to array
    *
    * @return array
    */
    public function toArray()
    {
        return json_decode(json_encode(ObjectSerializer::sanitizeForSerialization($this)), true);
    }
}


